/* Process model C form file: tcp_gwy.pr.c */
/* Portions of this file Copyright (C) MIL 3, Inc. 1992 */



/* OPNET system definitions */
#include <opnet.h>
#include "tcp_gwy.pr.h"
FSM_EXT_DECS



/* Header block */
#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)
#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)

#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

extern int TCP;




/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	Objid	                  		sv_my_id;
	Objid	                  		sv_ip_objid;
	int	                    		sv_sess;
	int	                    		sv_Indep_Rou;
	double	                 		sv_data_rec;
	int                     		sv_net_num0;
	int                     		sv_node_num0;
	int                     		sv_net_num1;
	int                     		sv_node_num1;
	int                     		sv_net_num2;
	int                     		sv_node_num2;
	int                     		sv_net_num3;
	int                     		sv_node_num3;
	int                     		sv_net_num4;
	int                     		sv_node_num4;
	} tcp_gwy_state;

#define pr_state_ptr            		((tcp_gwy_state*) SimI_Mod_State_Ptr)
#define my_id                   		pr_state_ptr->sv_my_id
#define ip_objid                		pr_state_ptr->sv_ip_objid
#define sess                    		pr_state_ptr->sv_sess
#define Indep_Rou               		pr_state_ptr->sv_Indep_Rou
#define data_rec                		pr_state_ptr->sv_data_rec
#define net_num0                		pr_state_ptr->sv_net_num0
#define node_num0               		pr_state_ptr->sv_node_num0
#define net_num1                		pr_state_ptr->sv_net_num1
#define node_num1               		pr_state_ptr->sv_node_num1
#define net_num2                		pr_state_ptr->sv_net_num2
#define node_num2               		pr_state_ptr->sv_node_num2
#define net_num3                		pr_state_ptr->sv_net_num3
#define node_num3               		pr_state_ptr->sv_node_num3
#define net_num4                		pr_state_ptr->sv_net_num4
#define node_num4               		pr_state_ptr->sv_node_num4




/* Process model interrupt handling procedure */



void
tcp_gwy ()
	{
	Packet  *pkptr,*ip_pkptr;
	int type,tmp_node,tmp_net,my_net,my_node;
	int pk_len;


	FSM_ENTER (tcp_gwy)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (init) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init")
			{
			my_id = op_id_self();
			ip_objid = op_topo_assoc (my_id, OPC_TOPO_ASSOC_OUT,
			                OPC_OBJMTYPE_MODULE, 0);
			 
			/* Use the object id to get the address */
			op_ima_obj_attr_get (ip_objid, "net_num0", &net_num0);
			op_ima_obj_attr_get (ip_objid, "node_num0", &node_num0);
			op_ima_obj_attr_get (ip_objid, "net_num1", &net_num1);
			op_ima_obj_attr_get (ip_objid, "node_num1", &node_num1);
			op_ima_obj_attr_get (ip_objid, "net_num2", &net_num2);
			op_ima_obj_attr_get (ip_objid, "node_num2", &node_num2);
			op_ima_obj_attr_get (ip_objid, "net_num3", &net_num3);
			op_ima_obj_attr_get (ip_objid, "node_num3", &node_num3);
			op_ima_obj_attr_get (ip_objid, "net_num4", &net_num4);
			op_ima_obj_attr_get (ip_objid, "node_num4", &node_num4);
			op_ima_obj_attr_get (ip_objid, "Indep_Rou", &Indep_Rou);
			
			/*Added by Jiemei */
			
			printf("Gwy_Tcp:  MyObjId %d  net_num %d %d %d %d %d node_num %d %d %d %d %d Indep_Rou %d\n",my_id,net_num0,net_num1,net_num2,net_num3,net_num4,node_num0,node_num1,node_num2,node_num3,node_num4,Indep_Rou);
			}


		/** state (init) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init")
			{
			}


		/** state (init) transition processing **/
		FSM_INIT_COND ((1))
		FSM_TEST_COND (PK_ARR)
		FSM_TEST_LOGIC ("init")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (idle) enter executives **/
		FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle")
			{
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (3,tcp_gwy)


		/** state (idle) exit executives **/
		FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle")
			{
			}


		/** state (idle) transition processing **/
		FSM_INIT_COND (PK_ARR)
		FSM_DFLT_COND
		FSM_TEST_LOGIC ("idle")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (pk_arr) enter executives **/
		FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "pk_arr")
			{
			ip_pkptr  = op_pk_get (op_intrpt_strm ());
			op_pk_nfd_get(ip_pkptr,"data", &pkptr);
			
			op_pk_nfd_get(pkptr,"type",&type);
			 
			if(type == 1)
			{       /*send back a accept for TCP connection*/
			        op_pk_nfd_get(ip_pkptr,"src_node",&tmp_node);
			        op_pk_nfd_get(ip_pkptr,"src_net",&tmp_net);
			        op_pk_nfd_get(ip_pkptr,"dest_node",my_node);
			        op_pk_nfd_get(ip_pkptr,"dest_net", my_net);
			        op_pk_nfd_set(ip_pkptr,"src_node",my_node);
			        op_pk_nfd_set(ip_pkptr,"src_net",my_net);
			if((my_net != net_num0 && my_node != node_num0) || (my_net != net_num1 && my_node != node_num1) || 
			         (my_net != net_num2 && my_node != node_num2) || (my_net != net_num3 && my_node != node_num3) 
			             || (my_net != net_num4 && my_node != node_num4))
			               op_sim_end("Tcp  at gwy is getting a pk which is not for him","","","");
			
			
			 
			        op_pk_nfd_set(ip_pkptr,"dest_net", tmp_net);
			        op_pk_nfd_set(ip_pkptr,"dest_node",tmp_node);
			        op_pk_nfd_set(ip_pkptr,"ttl",10);
			 
			        op_pk_nfd_set(pkptr,"type", 2);
			        pk_len=op_pk_total_size_get(pkptr);
			        op_pk_nfd_set(ip_pkptr,"data",pkptr);
			        op_pk_bulk_size_set(ip_pkptr,pk_len);
			/*        op_pk_send(pkptr,0);
			*/
				op_pk_send(ip_pkptr,0);
			}
			 
			else
			if(type == 0) { op_pk_destroy(pkptr);   op_pk_destroy(ip_pkptr);}
			
			
			 if(type == 2 || type == 3)op_sim_end("Tcp at gwy is getting a conn ack/n-ack why!!!","","","");
			
			
			
			}


		/** state (pk_arr) exit executives **/
		FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "pk_arr")
			{
			}


		/** state (pk_arr) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,tcp_gwy)
	}




void
tcp_gwy_svar (prs_ptr,var_name,var_p_ptr)
	tcp_gwy_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (tcp_gwy_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("my_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_my_id);
	if (Vos_String_Equal ("ip_objid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_ip_objid);
	if (Vos_String_Equal ("sess" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sess);
	if (Vos_String_Equal ("Indep_Rou" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_Indep_Rou);
	if (Vos_String_Equal ("data_rec" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_rec);
	if (Vos_String_Equal ("net_num0" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num0);
	if (Vos_String_Equal ("node_num0" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num0);
	if (Vos_String_Equal ("net_num1" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num1);
	if (Vos_String_Equal ("node_num1" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num1);
	if (Vos_String_Equal ("net_num2" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num2);
	if (Vos_String_Equal ("node_num2" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num2);
	if (Vos_String_Equal ("net_num3" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num3);
	if (Vos_String_Equal ("node_num3" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num3);
	if (Vos_String_Equal ("net_num4" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num4);
	if (Vos_String_Equal ("node_num4" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num4);

	FOUT;
	}




void
tcp_gwy_diag ()
	{
	Packet  *pkptr,*ip_pkptr;
	int type,tmp_node,tmp_net,my_net,my_node;
	int pk_len;

	FIN (tcp_gwy_diag ())


	FOUT;
	}




void
tcp_gwy_terminate ()
	{
	Packet  *pkptr,*ip_pkptr;
	int type,tmp_node,tmp_net,my_net,my_node;
	int pk_len;

	FIN (tcp_gwy_terminate ())


	FOUT;
	}



Compcode
tcp_gwy_init (pr_state_pptr)
	tcp_gwy_state			**pr_state_pptr;
	{
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (tcp_gwy_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (tcp_gwy)",
			sizeof (tcp_gwy_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (tcp_gwy_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



